<?php
//ferme la possibilité de commenté quand FALSE
$GLOBALS['openComment']=TRUE;
// enleve le captcha quand FALSE
$GLOBALS['captcha']=TRUE;
//temps en seconde avant de poster un message (antiflood)
$GLOBALS['timeFlood']=2;
//pour changer le répertoire, attention aucune garanti de bon fonctionnement si modifier.
$GLOBALS['repertoireComments']='./extensions/comments';
//nom du fichier où sont sauvegarder les commentaires
$GLOBALS['dataComment']='dataComment.comment';
// mode admin en off au démarrage à modifier avec commentSetAdmin()
$GLOBALS['adminMode']=FALSE;

//!!!!!!!!!!!!!!!!!!!!!!!!
//script ne pas toucher !!
//!!!!!!!!!!!!!!!!!!!!!!!!



//création du listcomments qui contient les commentaires sous forme de array imbriqué.
function createListComment($sujet=FALSE)
{
	$listComments = array();
	//on crée le fichier si il n'existe pas
	if(!is_file($GLOBALS['repertoireComments'].'/'.$GLOBALS['dataComment']))
	{
		file_put_contents($GLOBALS['repertoireComments'].'/'.$GLOBALS['dataComment'],serialize($listComments));
	}
	$commentTab=unserialize(@file_get_contents($GLOBALS['repertoireComments'].'/'.$GLOBALS['dataComment']));
	//si pas de sujet on renvoie la totalité des commentaires.
	if(!$sujet)
	{
		$listComments=$commentTab;
		return $listComments;
	}
	$i=0;
	$sizeCommentTab=count($commentTab);
	while ($i<$sizeCommentTab)
	{
		if ($commentTab[$i]['sujet']==$sujet)
		{
			$listComments[]=$commentTab[$i];
		}
		$i++;
	}
	return $listComments;
}

//controle pour savoir si l'utilisateur veut voir l'historique des commentaires
function seeLastComment()
{
	if(!empty($_GET['last']) AND $_GET['last']=='TRUE')
	{
	return TRUE;
	}
}

//bouton pour afficher l'historique des commentaires
function linkLastComment()
{
	$listComments=createListComment();
	echo '<a href="?last=TRUE" >Voir tous les commentaires('.count($listComments).')</a>';
}

//affichage de l'historique des commentaires classé en ordre décroissant
function showLastComment()
{
	$listComments=array_reverse(createListComment());
	$divComment='<div class="commentsDiv" style="display:block;" id="lastComment">';
	$ulComments='<div class="commentUl" >';
	foreach($listComments as $value)
	{
		$ulComments.='<div class="commentLi">
		<div class="commentMeta">';
		$lienSujet='<a class="commentLien" href="./?'.$value['sujet'].'&displayComment=TRUE">Voir le sujet commenté</a><br>';
		$ulComments.=$lienSujet;
		//rajout du vizhash si présent
		if($value['vizHash']!='')
			{
				$ulComments.='<img src="'.$value['vizHash'].'"class="vizhash" title="Anonymous avatar (Vizhash of the IP address)">';
			}
		$ulComments.='<strong class="commentPseudo">'.$value['pseudo'].':</strong>
		<em class="commentTime" >'.date("d/m/y - H:i",$value['time']).'</em>
		</div>
		<div class="commentData">'.$value['data'].'</div>
		</div>
		';
		//pour censurer
		if($GLOBALS['adminMode'])
		{
			$ulComments.='<form class="commentSuppr" method="post" action="'.$_SERVER["REQUEST_URI"].'" enctype="multipart/form-data">
			<input type="hidden"  name="sujetCensure"  value="'.$value['sujet'].'">
			<input type="hidden"  name="idCensure"  value="'.$value['id'].'">
			<input class="commentSubmit" type="submit" value="Censurer!"><br>
			<input type="txt" placeholder="motif?" name="motifCensure">
			</form><br>';
		}
	}
	$ulComments.='</div><br>';
	$divComment.=$ulComments.'</div>';
	echo $divComment;
}

//le formulaire du captcha qui se sert du captcha de tontof
function formCaptcha()
{
	$formCaptcha='';
	if($GLOBALS['captcha'])
	{
		require_once($GLOBALS['repertoireComments'].'/include/tontof_captcha.php');
		$captcha=new Captcha();
		if(empty($_SESSION['captcha']))
		{
		$_SESSION['captcha']=$captcha->generateString();
		}
		$formCaptcha='<label for="toctoc">Recopiez ces caractères : <br><strong class="toctoc">'.$captcha->convertString($_SESSION['captcha']).'</strong></label>
			<br>
		 	<input type="text" name="toctoc" id="toctoc" /><br />';
	}
	return $formCaptcha;
}

//on affiche le formulaire pour rajouter un commentaire
function formComment($sujet)
{
	$commentForm='<div class="commentForm">Les commentaires sont fermés.</div>';
	if($GLOBALS['openComment']){
	$commentForm='<form class="commentForm" method="post" action="'.$_SERVER["REQUEST_URI"].'#commentId_'.$sujet.'" enctype="multipart/form-data">
    <label class="commentLabelPseudo" for="pseudo">Pseudo: </label><br>
    <input class="commentInputPseudo" type="txt" id="commentPseudo" name="commentPseudo" maxlength="30" size="30" placeholder="Anonyme?" value="'.$_SESSION['lastPseudo'].'" ><br><br>
    <label class="commentLabelSiteOueb" for="commentSiteOueb">Un site web ?: </label><br>
    <input class="commentSiteOueb" type="txt" id="commentSiteOueb" name="commentSiteOueb" size="30" placeholder="(Facultatif)" value="'.$_SESSION['siteOueb'].'" ><br><br>
    <label class="commentLabelTexte" for="commentaire">Commentaire: </label><br>
    <TEXTAREA class="commentTextareaTexte" id="commentData" name="commentData" placeholder="Rediger votre commentaire..." rows=5 style="width:60%;" required>'.$_SESSION['lastCom'].'</TEXTAREA><br>
    <br>
    <input type="hidden"  name="sujet"  value="'.$sujet.'">'.formCaptcha().'
    <br>
    <input class="commentSubmit" type="submit" value="Envoi">

	</form>';
	}
	return $commentForm;
}

// si on est en admin mode on censure le commentaire
function censureComment($sujet,$idCensure)
{
	$motif='';
		if(!empty($_POST['motifCensure']))
					{
						$motif.= '<br>Motif: '.$_POST['motifCensure'];
					}
		$newData='Censurer le '.date("d/m/y à H:i").$motif;
		$listComments=createListComment();
		$listComments[$idCensure]['data']=$newData;
		file_put_contents($GLOBALS['repertoireComments'].'/'.$GLOBALS['dataComment'],serialize($listComments));
}

//on remplace les url et smiley dans le commentaire
//merci tontof pour l'utilisation du meme preg_repace du shaarli
function replaceComment($commentData)
{
	$commentData = preg_replace('!(((?:https?|ftp|file)://|apt:)\S+[[:alnum:]]/?)!si','<a href="$1" rel="nofollow">$1</a>',$commentData);
	return $commentData;
}

//on coupe le texte si trop long (utiliser uniquement pour les pseudos mais peu etre utiliser pour les commentaires
function cutText($texte,$size)
{
	$max = $size; //nombre de caractère autoriser
	if (strlen($texte) > $max)
	{
		$texte = substr($texte, 0, $max);
		$lastSpace = strrpos($texte, " ");
		$texte = substr($texte, 0, $lastSpace)."(texte trop long...)";
	}
	return $texte;
}

//on ajoute un nouveau commentaire fonction de la résolution du captcha bien sur
function addComment($sujet,$commentData)
{
		//on met un sleep pour les floodeurs.
		sleep($GLOBALS['timeFlood']);
		$_SESSION['lastCom']=$commentData;
		if(!empty($_POST['commentPseudo']))
		{
			$_SESSION['lastPseudo']=cutText(strip_tags(ucfirst($_POST['commentPseudo'])),30);
			$pseudo=$_SESSION['lastPseudo'];
			if(!empty($_POST['commentSiteOueb']))
			{
				$_SESSION['siteOueb']=$_POST['commentSiteOueb'];
			$pseudo=preg_replace('!(((?:https?|ftp|file)://|apt:)\S+[[:alnum:]]/?)!si','<a href="$1" rel="nofollow">'.$pseudo.'</a>',$_POST['commentSiteOueb']);
			}
			require_once($GLOBALS['repertoireComments'].'/include/vizhash_gd_zero.php');
			$vz = new vizhash16x16();
			$pngdata = $vz->generate($_SERVER['REMOTE_ADDR']);
			if ($pngdata!='')
				{
					$vizHash = 'data:image/png;base64,'.base64_encode($pngdata);
				}
		}
		else
		{
			$pseudo='Anonyme';
			$vizHash='';
		}
		// si il y a un captcha est que ce n'est pas le bon on ne fait plus rien
		if($GLOBALS['captcha'] AND  strtoupper($_POST['toctoc'])!=$_SESSION['captcha'] )
		{
			unset($_SESSION['captcha']); //actualisation du captcha
			return  ;
		}
		//captcha ou pas on en regénére un
		unset($_SESSION['captcha']);

		$time=time();
		$data = nl2br(replaceComment(strip_tags(trim($commentData))));
		$listComments=createListComment();
		$id=count($listComments);
		$listComments[]=array('id'=>$id,'pseudo'=>$pseudo,'vizHash'=>$vizHash,'sujet'=>$sujet,'time'=>$time,'data'=>$data);
		$_SESSION['lastCom']='';
		file_put_contents($GLOBALS['repertoireComments'].'/'.$GLOBALS['dataComment'],serialize($listComments));
}

//on affiche les commentaires déjà existant
function showListComments($sujet,$listComments)
{

	$ulComments='<div class="commentUl">';
	foreach($listComments as $value)
	{

		$ulComments.='<div class="commentLi" >
		<div class="commentMeta">';

		//rajout du vizhash si présent
		if($value['vizHash']!='')
			{
				$ulComments.='<img src="'.$value['vizHash'].'"class="vizhash" title="Anonymous avatar (Vizhash of the IP address)">';
			}

		$ulComments.='<strong class="commentPseudo">'.$value['pseudo'].':</strong>
		<em class="commentTime" >'.date("d/m/y - H:i",$value['time']).'</em>
		</div>
		<div class="commentData">'.$value['data'].'</div>
		</div>
		';
		//pour censurer
		if($GLOBALS['adminMode'])
		{
			$ulComments.='<form class="commentSuppr" method="post" action="'.$_SERVER["REQUEST_URI"].'#commentId_'.$sujet.'" enctype="multipart/form-data">
			<input type="hidden"  name="sujetCensure"  value="'.$sujet.'">
			<input type="hidden"  name="idCensure"  value="'.$value['id'].'">
			<input class="commentSubmit" type="submit" value="Censurer!"><br>
			<input type="txt" placeholder="motif?" name="motifCensure">

			</form><br>';
		}
	}
	$ulComments.='</div><br>';
	return $ulComments;
}

//on crée un commentaire en rapport avec un "sujet"
function createComment($sujet)
{
	$listComments=createListComment($sujet);

	$nbreComments='<br><div class="nbreComment" onclick="afficherCom(\'commentId_'.$sujet.'\');">
	Commentaires('.count($listComments).')
	</div>';

	$divComment=$nbreComments.'<div class="commentsDiv" id="commentId_'.$sujet.'"';
	//ne cache pas le div de commentaires ou l'on viens de poster
	if((!empty($_POST['sujet']) AND $_POST['sujet']==$sujet) OR
	(!empty($_POST['sujetCensure']) AND $_POST['sujetCensure']==$sujet) OR
	(!empty($_GET['displayComment']) AND $_GET['displayComment']==TRUE))
	{
			$divComment.='style="display:block;"';
	}
	$divComment.='>'.showListComments($sujet,$listComments).formComment($sujet).
	'</div>';
	echo $divComment;
}

//on passe en mode admin, a insérer dans la partie ou on se log
function commentSetAdmin()
{
	$GLOBALS['adminMode']=True;
}

//controle de la présence de POST et intégration du javascript et css, à lancé au démarrage du script.
function loadComment()
{
if(!isset($_SESSION['lastCom']))
{
	$_SESSION['lastCom']='';
}
if(!isset($_SESSION['lastPseudo']))
{
	$_SESSION['lastPseudo']='';
}
if(!isset($_SESSION['siteOueb']))
{
	$_SESSION['siteOueb']='';
}



//on traite les formulaires si il y en as
if(!empty($_POST['commentData']) AND !empty($_POST['sujet']))
{
	addComment($_POST['sujet'],$_POST['commentData']);
}
if(isset($_POST['idCensure']) AND !empty($_POST['sujetCensure']) AND $GLOBALS['adminMode'] )
{
	censureComment($_POST['sujetCensure'],$_POST['idCensure']);
}
//javascript
$script='<script>'.file_get_contents($GLOBALS['repertoireComments'].'/jsComment.js').'</script>';
//style des commentaires
$style='<style>'.file_get_contents($GLOBALS['repertoireComments'].'/cssComment.css').'</style>';
echo $script.$style;
}
?>
